close all; keep pphome; 
%% Schnakenberg sphere, R=10
R=10; dir='R10'; 
%%
nx=41; ny=31; dsmin=0.01; dsmax=0.011; 
p=[]; par=[3.21 0 60 R 0]; lx=pi; del=1e-3; ly=pi/2-del; ref=1; ye=1.2; 
p=schnakSinit(p,[lx,ly],nx,par,ref,ye); p.np, p.pm.resfac=1e-4; p.sol.ds=-dsmin; p.sw.verb=2; 
p.nc.dsmax=dsmax; p.nc.dsmin=dsmin; p=setfn(p,dir); p.nc.mu2=0.01; p.nc.tol=1e-6; p0=p; 
%%
p=cont(p,10);
%% BP1, l=6, using qswibra with besw=0 to just compute many 'almost' kernel vectors ...
aux=[]; aux.m=13; aux.soltol=1e-14; aux.isotol=1e-20; aux.besw=0; 
bp='bpt1'; aux.ali=[1 3 5 7 9 11 13]; aux.besw=1; % l=6
p0=qswibra(dir,bp,aux); p0.nc.dsmin=0.01; p0.sw.bifcheck=0; p0.nc.dsmax=0.051; 
p0.pm.resfac=1e-2; p0.sol.ds=0.05; 
%%
p=seltau(p0,1,'10-1a',2); p=cont(p,3); spplot(p); pause; p.nc.tol=1e-5; p.sol.ds=-0.05; 
p.nc.nq=1;p.nc.ilam=[1 5]; p=pmcont(p,20); spplot(p);
%%
p=seltau(p0,1,'10-1b',2); p.sol.ds=-0.05; p=cont(p,5); spplot(p); pause;  p.nc.tol=1e-5;
p.nc.nq=1;p.nc.ilam=[1 5]; p=pmcont(p,20); spplot(p);
%% nice pentagon! 
p=seltau(p0,2,'10-2a',2); p=cont(p,3); spplot(p); pause; 
p.nc.nq=1;p.nc.ilam=[1 5]; p=pmcont(p,20); spplot(p);
%%
p=seltau(p0,2,'10-2b',2); p.sol.ds=-0.05; p=cont(p,5); spplot(p); pause; 
p.nc.nq=1; p.nc.ilam=[1 5]; p=pmcont(p,20); spplot(p);
%% stripes
%p=gentau(p0,[0 0 0 0 0 0 0 0 0 0 0 0 1],'10-13a');
p=gentau(p0,[0 0 0 0 0 0 1],'10-13a'); % if qswibra with ali
p1=p; pause; p=pmcont(p,15); spplot(p);
%%
p=p1; p.sol.ds=-0.05; pause; p=pmcont(p,15); spplot(p);
%% BP2, l=5; using cswibra with besw=0 to just compute many 'almost' kernel vectors ...
aux=[]; aux.m=13; aux.soltol=1e-14; aux.isotol=1e-16; aux.besw=0; 
bp='bpt2'; aux.ali=[1 2 4 6 8 10]; aux.besw=1; % l=6
p0=cswibra(dir,bp,aux); p0.nc.dsmin=0.01; p0.sw.bifcheck=0; p0.nc.dsmax=0.051; 
p0.pm.resfac=1e-2; p0.sol.ds=0.025; 
%%
p=seltau(p0,3,'10b-3',3); pause; p.sol.ds=-0.05; p=cont(p,3); spplot(p); pause; 
p.nc.nq=1;p.nc.ilam=[1 5]; p=pmcont(p,10); spplot(p);
%%
p=gentau(p0,1,'10b-1'); pause; p=pmcont(p,20); spplot(p); 
%% plot BD 
fnr=3; figure(fnr); clf; pcmp=6; plotbra(dir,'bpt2',fnr,pcmp,'cl','k','lsw',0);
plotbra('10-1a','pt19',fnr,pcmp,'cl',p2pc('r1'),'lab',10); 
plotbra('10-1b',fnr,pcmp,'cl',p2pc('r1'),'lab',10); 
plotbra('10-2a',fnr,pcmp,'cl',p2pc('b2'),'lab',19); 
plotbra('10-2b',fnr,pcmp,'cl',p2pc('b2'),'lab',20); 
plotbra('10-13a',fnr,pcmp,'cl',p2pc('o2'),'lab',8); 
plotbra('10-13b',fnr,pcmp,'cl',p2pc('o2'),'lab',13); 
plotbra('10b-1',fnr,pcmp,'cl',p2pc('g1'),'lab',6); 
plotbra('10b-3','pt10',fnr,pcmp,'cl',p2pc('g2'),'lab',7); 
axis([2.98 3.23 3.01 4.8]); 
ylabel('max u_1'); 
%% solution plots 
spplotf('10-1a','pt10'); pause; spplotf('10-1b','pt10'); pause; 
%%
spplotf('10-2a','pt19'); pause; spplotf('10-2b','pt20'); pause; 
spplotf('10-13a','pt8'); pause; spplotf('10-13b','pt13'); 
%%
spplotf('10b-1','pt6'); pause; spplotf('10b-3','pt7'); pause;
%% cont in R, penta-branch 
p=swiparf('10-2a','pt19','10-2aR',[4 5]); huclean(p); p.sw.bifcheck=2; 
p.sol.ds=0.1; p.nc.mu1=1e-2; p.sw.bifcheck=0; p.pm.resfac=1e-4;   
p.nc.tol=1e-5; p=pmcont(p,10); p.nc.tol=1e-4; p=pmcont(p,10);
%%
p=swiparf('10-2a','pt19','10-2aRb',[4 5]); huclean(p); p.sw.bifcheck=2; 
p.sol.ds=-0.1; p.nc.tol=1e-5; p.pm.resfac=1e-3;  p.sw.bifcheck=0;   p=cont(p,20);
%% cont in R, stripes 
p=swiparf('10-13a','pt8','10-13aRa',[4]); huclean(p); p.sw.bifcheck=2; 
p.sol.ds=0.1; p.nc.tol=1e-4; p.pm.resfac=1e-4;  p=pmcont(p,30);
%%
p=swiparf('10-13a','pt8','10-13aRb',[4]); huclean(p); p.sw.bifcheck=2; 
p.sol.ds=-0.1; p.nc.tol=1e-6; p.pm.resfac=1e-4;   p=pmcont(p,20);
%% secondary
p=swibra('10-13aRb','bpt1','s1',-0.01); p.nc.tol=1e-5; p=pmcont(p,20);
%%
fnr=3; figure(fnr); clf; pcmp=6; plotbra('10-2aR','pt50',fnr,pcmp,'cl','b','lab',50);
plotbra('10-2aRb','pt20',fnr,pcmp,'cl','b','lab',20);
plotbra('10-13aRa','pt30',fnr,pcmp,'cl',p2pc('o2'),'lab',30);
plotbra('10-13aRb','pt20',fnr,pcmp,'cl',p2pc('o2'),'lab',20);
plotbra('s1','pt20',fnr,pcmp,'cl',p2pc('o3'),'lp',22,'lab',20);
%%
spplotf('10-2aR','pt50'); pause; spplotf('10-2aRb','pt20'); pause 
spplotf('10-13aRa','pt30'); pause; spplotf('10-13aRb','pt20'); pause;
spplotf('s1','pt20');
