%% commands for Schnakenberg on longer domain, with snaking
close all; keep pphome; 
p=[]; kc=sqrt(sqrt(2)-1); lx=8*pi/kc; ly=lx/sqrt(3)/4; nx=140; par=[3.3, 0, 60]; 
sw.sym=2; p=schnakinit(p,[lx,ly],nx,par,sw); % init with criss-cross mesh 
p.fuha.outfu=@schnakbra; p=setfn(p,'bhom'); p=cont(p,10);
%% hex+ via qswibra
aux=[]; aux.m=2; p0=qswibra('bhom','bpt1',aux); p0.sol.ds=-0.1; p0.sw.bifcheck=1;
p=seltau(p0,3,'bh+',2);% p=pmcont(p,30); 
%% stripes+ via gentau 
p=gentau(p0,1); p=setfn(p,'bs+');% p=pmcont(p,30);
%% b+ 
p=swibra('bs+','bpt5','bb+',-0.05); p.nc.dsmin=0.05;  p=pmcont(p,25);
%% snake of loc. hex over stripes 
ds=-0.025; p=swibra('bb+','bpt3','sn1',ds); p.nc.dsmin=ds; p.nc.dsmax=ds;  
p.file.smod=5; p.sw.bifcheck=0; p=pmcont(p,50);
%% plot BD 
fnr=3; figure(fnr); clf; cmp=6; 
plotbra('bhom','bpt2',fnr,cmp,'cl','k'); plotbra('bs+','pt20',fnr,cmp,'cl','b'); 
plotbra('bh+','pt30',fnr,cmp, 'cl','m'); plotbra('bb+','pt25',fnr,cmp,'cl','r','lab',10,'lp',18); 
plotbra('sn1','pt50',fnr,cmp, 'cl','k','lab',[25 35]); 
axis([2.4 3.25 3.18 4.2]); xlabel('\lambda'); ylabel('||u||_8'); 
%% soln plot 
p=loadp('sn1','pt20'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'sn1/pt20'); pause
p=loadp('sn1','pt30'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'sn1/pt30'); pause
p=loadp('bb+','pt10'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'bb+/pt10'); 