%% bif from periodic orbit example 
close all; format compact; keep pphome; 
%% init
ndim=1; dir='hom1d'; p=[]; lx=pi/1.4; nx=50; 
par=[0.95; 2.75; 1; 1; 0.01; 0.1; 1]; % a, b, c, d, Du, Dv, Dw 
p=bruinit(p,lx,nx,par,ndim); p=setfn(p,dir); 
p.sw.bifcheck=2; p=initeig(p,4); p.nc.neig=[5, 5];  %pause % initeig 
p.sw.verb=0; p.nc.mu2=5e-3; p.nc.bisecmax=10; p=cont(p,20); % cont (with bifpoint detection) 
%% Hopf bifs from HBPs
para=4; ds=0.1; dsmax=0.1; xi=1e-3; nsteps=20; figure(2); clf; 
aux=[]; aux.tl=30; 
p=hoswibra('hom1d','hpt1',ds,para,'1dh1',aux); 
p.hopf.xi=xi; p.hopf.jac=1; p.nc.dsmax=dsmax; p.sw.verb=0;  p.file.smod=1; 
p=setbel(p,2,1e-4,5,@lss); p.hopf.fltol=1e-4; 
t1=tic; p=cont(p,nsteps); toc(t1) 
%% reload a point from 1dh1 and run with hobifdetec
p=loadp('1dh1','pt10'); p.hopf.bisec=2; p=cont(p,5); 
%%
ds=0.1; pt='bpt1'; aux.one=1; p=poswibra('1dh1',pt,'t1',ds,aux); pause
p.nc.tol=1e-6; p.sw.bifcheck=0; p.hopf.fltol=1e-2; % large amplitude, hence relax fltol 
huclean(p); p=cont(p,3); p0=p; p=cont(p,7); 
p=p0; p=resetc(p); p=setfn(p,[p.file.dir 'b']); 
%p.sol.ds=-p.sol.ds; p=cont(p,6); % other direction
%%
ds=0.5; pt='bpt2'; aux.one=1; p=poswibra('1dh1',pt,'t2',ds,aux); pause
p.nc.tol=1e-6; p.sw.bifcheck=0; p.hopf.fltol=1e-2; huclean(p); p=cont(p,100); 
%%
ds=0.5; pt='bpt2'; aux.one=1; p=poswibra('1dh1',pt,'t2b',ds,aux); pause
p.nc.tol=1e-6; p.sw.bifcheck=0; p.hopf.fltol=1e-2; % large amplitude, hence relax fltol 
huclean(p); p=cont(p,3); %p.nc.tol=1e-3;
p=cont(p,37); 

%% plot BD, L^2
bpcmp=9; wnr=4; figure(wnr); clf; plotbra('hom1d','pt45',wnr,bpcmp,'cl','k'); 
plotbra('1dh1','pt30',wnr,bpcmp,'cl',[1 0.5 0]); 
plotbra('t1','pt30',wnr,bpcmp,'cl','r','lab',[10],'fp',0); 
plotbra('t2','pt100',wnr,bpcmp,'cl','m','lab',[70 83],'fp',0); 
%plotbra('t1b','pt5',wnr,bpcmp,'cl','r','lsw',0); 
xlabel('b'), ylabel('||u||_\infty'); 
%axis([2.75 3.25 2.75 5]); 
%% soln and floquet plotting 
aux.nfloq=100; v=[15,60];
dir='1dh1'; pt='bpt1'; hoplotf(dir,pt,1,1); figure(1); title(['u1 at ' dir '/' pt]); 
colormap cool; shading interp; view(v); muv1=floqap(dir,pt,aux); pause 
pt='bpt2'; hoplotf(dir,pt,1,1); figure(1); title(['u1 at ' dir '/' pt]); 
colormap cool; shading interp; view(v); muv1=floqap(dir,pt,aux); pause
dir='t1'; pt='pt10'; hoplotf(dir,pt,1,1); figure(1); title(['u1 at ' dir '/' pt]); 
colormap cool; shading interp; view(v); muv1=floqap(dir,pt,aux); pause
dir='t2'; pt='pt70'; hoplotf(dir,pt,1,1); figure(1); title(['u1 at ' dir '/' pt]); 
colormap cool; shading interp; view(v); muv1=floqap(dir,pt,aux); pause
%%
pt='pt83'; hoplotf(dir,pt,1,1); figure(1); title(['u1 at ' dir '/' pt]); 
colormap cool; shading interp; view(v); muv1=floqap(dir,pt,aux); 