function A=gethoA(p,jac,f_T,f_lam,pc_y,tau,varargin)
% gethoA: build extended Jac for Hopf-arclength setting
if nargin>6;  f_a=varargin{1}; qhder=0;  nqh=p.hopf.nqh; 
    if nargin>7; qhder=varargin{2}; end 
end
try; freeT=p.freeT; catch; freeT=1; end % check if T is free (default) 
xi=p.hopf.xi; tw=p.hopf.tw; nu=p.nu; na=nu+p.nc.nq; tl=p.hopf.tl; 
if freeT; 
 pc_T=0; 
 A=[[jac, f_T, f_lam];
    [pc_y, pc_T, 0];  
    [xi*tau(1:na*tl), (1-xi)*tw*tau(na*tl+1), (1-xi)*(1-tw)*tau(na*tl+2)]];
 if nqh>0; A=[[A [f_a; zeros(2,nqh)]]; qhder]; end 
else % T fixed, no \pa_T(G) column in A 
A=[[jac, f_lam, f_a];
    [pc_y, 0, zeros(1,nqh+1)];  
    [xi*tau(1:na*tl), (1-xi)*tau(na*tl+1:na*tl+2+nqh)]];
    if nqh>0; A=[A; qhder]; end 
end
%spy(A), pause; %nqh, size(qhder), size(A)