function p=hoiniguess(p,t,u,varargin)
% hoiniguess: generate iniguess for Hopf by hand 
% set-up data-structures to subseq.call honloop(ext) or (ho)cont
% t=time-discret, tl points
% u=matrix nu x tl
% nqh=
% spatial discret., FEM matrices etc already in p 
% essentially mimics hoswibra
aux=[]; if nargin>3; aux=varargin{1}; end 
try nqh=aux.nqh; catch nqh=0; end 
try ds=aux.ds; catch; ds=0.1; end 
p=hostanparam(p); % set standard values 
tl=length(t); T=t(end); p.hopf.tl=tl; p.hopf.t=t./T; % rescaled discr.
p.hopf.T=T; nu=p.nu; p.hopf.xi=p.hopf.xif/(nu*tl); 
lam=getlam(p); dlam=0; p.hopf.lam=lam; 
p=resetc(p); brout=[bradat(p); p.fuha.outfu(p,p.u)]; brout(1,1)=0; 
p.hopf.y=u; 
p.hopf.nqh=nqh; 
hoplot(p,p.plot.pfig,p.plot.pcmp,p.hopf.aux); 
figure(p.plot.pfig); title('initial guess');
p.sw.para=4; p.sw.spcalc=0; p=hoMini(p); p.sol.ds=ds; par=p.u(p.nu+1:end); 
p.sol.restart=0; % don't treat as a restart (would need a bit more 'tuning'), 
tau=zeros(1,nu*tl+2+nqh);     % the Hopf tangent vector
for i=1:tl; si=(i-1)*nu+1; % fill u-part of tangent   (here with u itself (coming from 0)   
    tau(si:si+nu-1)=u(:,i)/ds;  end;  
tau=tau/honorm(p,tau); p.hopf.tau=tau; 
p.hopf.y0d=sety0dot(p,p.hopf.y,par,p.hopf.T); % phase cond 
%p.branch=brout; p.file.count=0; p.sol.ptype=3; p.fuha.savefu(p);p.file.count=1; 
